#include "include.h"
#include "macro.h"

#include "Objtile.h"

#define MAX_TILE 256		// Nombre maximun de tiles ouvrable
#define MAX_ANI_TILE 256	// Nombre maximun de tiles animables
#define MXS FILENAME_MAX	// Longueur a reserver aux noms de fichiers

/* On n'ajoute que ce qui est necessaire ! */
   BEGIN_GFX_DRIVER_LIST
   GFX_DRIVER_VBEAF
   GFX_DRIVER_VGA
//   GFX_DRIVER_MODEX
   GFX_DRIVER_VESA3
   GFX_DRIVER_VESA2L
   GFX_DRIVER_VESA2B
//   GFX_DRIVER_XTENDED
   GFX_DRIVER_VESA1
   END_GFX_DRIVER_LIST

   BEGIN_COLOR_DEPTH_LIST
   COLOR_DEPTH_8
//   COLOR_DEPTH_15
//   COLOR_DEPTH_16
//   COLOR_DEPTH_24
//   COLOR_DEPTH_32
   END_COLOR_DEPTH_LIST

   BEGIN_DIGI_DRIVER_LIST
//   DIGI_DRIVER_SOUNDSCAPE
//   DIGI_DRIVER_AUDIODRIVE
//   DIGI_DRIVER_SB
   END_DIGI_DRIVER_LIST

   BEGIN_MIDI_DRIVER_LIST
//   MIDI_DRIVER_AWE32
//   MIDI_DRIVER_DIGMID
//   MIDI_DRIVER_ADLIB
//   MIDI_DRIVER_MPU
//   MIDI_DRIVER_SB_OUT
   END_MIDI_DRIVER_LIST

   BEGIN_JOYSTICK_DRIVER_LIST
//   JOYSTICK_DRIVER_STANDARD
//   JOYSTICK_DRIVER_SIDEWINDER
//   JOYSTICK_DRIVER_GAMEPAD_PRO
//   JOYSTICK_DRIVER_SNESPAD
//   JOYSTICK_DRIVER_WINGWARRIOR
   END_JOYSTICK_DRIVER_LIST

// Def
#define SX 640
#define SY 480

// Structure
typedef struct
{
 ub	tile;		// Tile de base
 ub	freq;		// Frequence
 ub	type;		// Type
 ub	extra;		// Extra option
} ani;

void	set_gfx();
void	disp_tiles();

// Global var
BITMAP  *buffer;

BITMAP	*tile_base[MAX_TILE];
 ul	no_tile = 0;		// Nombre de tiles dans le fichier

int	main(int argc, char *argv[])
{
 char	chaine[256];
 ul	i=0;
 ub	on_continue=1;
 ani	ani_tile[MAX_ANI_TILE];
 ul	no = 0;	// Nombre de tiles anims

 /* double buffer the animation */
 if ((buffer = create_bitmap(SX, SY)) == NULL)
      {
	allegro_exit();
       puts("Error when creating double-bufffer !");
       return 1;
      };
 puts("Double-buffer ok !");

 set_gfx();

 chaine[0]=0;
 if (!(no_tile = load_tile(chaine, 2, 16, tile_base)))
	{
	printf("Error : no_tile = %u", no_tile);
	return 3;
	}

 disp_tiles();
 readkey();
 save_pcx("tile.pcx",buffer,desktop_pallete);
 allegro_exit();
 return 0;
};

void	disp_tiles()
{
uw 	x=0,y=0,j=0;
char	chaine[10];

clear(buffer);
while (((y+16) < SCREEN_H) && (j < no_tile))
	{
	x = 0;
	while (((x+40) < SCREEN_W) && (j < no_tile))
		{
		sprintf(chaine,"%u",j);
		textout(buffer,font,chaine,x,y,5);
		print_tile(x+24, y, j, 16, tile_base);
		j++;
		x+= 40;
		}
	y+=17;
	}
scare_mouse();
blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}

void	set_gfx()
{
 // Allegro
 allegro_init();
 install_keyboard();
 install_mouse();
 install_timer();
 set_gfx_mode(GFX_AUTODETECT, SX, SY, 0, 0);
 set_pallete(desktop_pallete);
 show_mouse(screen);
}

void	set_text()
{
 allegro_exit();
}

ub select_tile(void)
{
 uw y;
 ul i,j,k,t,a;
 ub cont= TRUE;
 i = k = 0;

 while (cont)
       {
       y = 0;
       j = i;
       clear(buffer);
       while ((y+16) < SCREEN_H)
             {
             print_tile(50, y, j, 16, tile_base);
             if (j == k) print_selected_tile(50, y, j, 16);
             j++;
             y+= 17;
             }
       scare_mouse();
       blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
       unscare_mouse();
       readkey();
       if (key[KEY_ESC]) cont=FALSE, k= 255;
       if (key[KEY_UP])
           if (k > 0)
              {
              k--;
              if (i > k) i = k;
              }
       if (key[KEY_DOWN])
          if (k < no_tile)
             {
             k++;
             if (k >= j) i++;
             }
       if (key[KEY_PGUP])
	 for (a = 0 ; a < 15 ; a++)
	           if (k > 0)
        	      {
       		       k--;
       		       if (i > k) i = k;
              	      }
       if (key[KEY_PGDN])
	 for (a = 0 ; a < 15 ; a++)
          if (k < no_tile)
             {
             k++;
             if (k >= j) i++;
             }
       if (key[KEY_ENTER])
          cont= FALSE;
       }
 return k;
}

ub select_item(char *chaine[], ub max)
{
 ub i;

 for(i = 0 ; i < max ; i++)
	printf("%u -> %s\n",i,chaine[i]);
 while (i >= max)
	{
	printf("Enter frequency :");
	scanf("%u",&i);
	}
 return i;
}

ub select_freq(void)
{
 static char *chaine[]={"30 Hz", "15 Hz", "7.5 Hz", "3.25 Hz", "1.12 Hz", "0.55 Hz"};
 return select_item(chaine, 6);
}

ub select_type(void)
{
 static char *chaine[]={"Rotation Up", "Rotation Down","Rotation Left", "Rotation right",
			 "Exchange tiles"};
 return select_item(chaine,5);
}

ub select_extra(void)
{
 ub i;
 printf("Entrer extra-information :");
 scanf(&i);
 return i;
}
